               /*Ŀ
                                                                        
                  chars = functions to write characters with specified  
                          foreground and background colors.             
                                                                        
                 */

#include <stdio.h>
#include <dos.h>
#include "chars.h"
#include "gdraws.h"

void write_horz_char(int x, int y, int ch, int color)
{

	int char_offset;

	convert(x,y);

        #ifdef CGA

	char_offset = (ch - 32) * 8;

	#endif

	#ifndef CGA

	char_offset = (ch - 32) * 14;

	#endif

	plot_char(x,y,char_offset,color,0);
	}

void write_vert_char(int x, int y, int ch, int color)
{
	int char_offset;

	convert(x,y);

        #ifdef CGA

	char_offset = (ch - 32) * 8;

	#endif

	#ifndef CGA

	char_offset = (ch - 32) * 14;

	#endif

	plot_char(x,y,char_offset,color,1);
	}


void write_horz_str(int x, int y, char *string, int color)
{
	int char_offset,p=0;

	convert(x,y);
	while (string[p])
	{

	        #ifdef CGA

		char_offset = (string[p] - 32) * 8;

		#endif

		#ifndef CGA

		char_offset = (string[p] - 32) * 14;

		#endif

		plot_char(x,y,char_offset,color,0);
		x += 8;

		#ifdef CGA

		if (x>312)
		{
			x=0;
			y -= 8;
		}
		#endif

		#ifndef CGA
		if (x>632)
		{
			x=0;
			y -= 14;
		}
		#endif
		p++;
	}
}

void write_vert_str(int x, int y, char *string, int color)
{
	int char_offset,p=0;

	convert(x,y);
	while (string[p])
	{
	        #ifdef CGA

		char_offset = (string[p] - 32) * 8;

		#endif

		#ifndef CGA

		char_offset = (string[p] - 32) * 14;

		#endif

		plot_char(x,y,char_offset,color,1);
		y -= 8;
		if (y<8)
		{
			#ifdef VGA
			y=472;
			x += 14;
			#endif

			#ifdef EGA
			y=342;
			x += 14;
			#endif

			#ifdef VGA
			y=192;
			x += 8;
			#endif
		}
		p++;
	}
}

void write_big_char(int x, int y, int ch, int color)
{
	int char_offset;

	convert(x,y);

	#ifdef CGA
	char_offset = (ch - 32) * 8;
	#endif

	#ifndef CGA
	char_offset = (ch - 32) * 14;
	#endif

	plot_char(x,y,char_offset,color,2);
}

void write_vid_char(int x, int y, int ch, int color)
{
	int char_offset;

	convert(x,y);

	#ifdef CGA
	char_offset = (ch - 32) * 8;
	#endif

	#ifndef CGA
	char_offset = (ch - 32) * 14;
	#endif

	plot_char(x,y,char_offset,color,3);
}

void write_big_str(int x, int y, char *string, int color)
{
	int p=0,char_offset;

	convert(x,y);

	while (string[p])
	{
		#ifdef CGA
		char_offset = (string[p] - 32) * 8;
		#endif

		#ifndef CGA
		char_offset = (string[p] - 32) * 14;
		#endif

		plot_char(x,y,char_offset,color,2);
		x += 32;

		#ifdef CGA
		if (x>287)
		{
			x=0;
			y += 32;
		}
		#endif

		#ifndef CGA

		if (x>607)
		{
			x=0;
			y += 56;
		}
		#endif
		p++;
	}
}

void write_vid_str(int x, int y, char *string, int color)
{
	int p=0,char_offset;

	convert(x,y);
	while (string[p])
	{
		#ifdef CGA
		char_offset = (string[p] - 32) * 8;
		#endif

		#ifndef CGA
		char_offset = (string[p] - 32) * 14;
		#endif

		plot_char(x,y,char_offset,color,3);
		x += 32;

		#ifdef CGA
		if (x>287)
		{
			x=0;
			y += 32;
		}
		#endif

		#ifndef CGA

		if (x>607)
		{
			x=0;
			y += 56;
		}
		if (x>607)
		{
			x=0;
			y += 56;
		}
		#endif
		p++;
	}
}

void plot_char(int x, int y, int char_offset,int color, int type)
{

	#define seq_out(index,val)  {outp(0x3C4,index);\
					 outp(0x3C5,val);}
	#define graph_out(index,val)  {outp(0x3CE,index);\
					 outp(0x3CF,val);}

	unsigned int offset;
	char far * mem_address;
	unsigned char char_test, exist_color;
	int i, j, k, m, start, end,height,width,foreground,background,
		point_color,dummy,mask;

	foreground = color & 0x0F;
	background = (color & 0xF0) >> 4;
	switch(type)
	{
		case 0:
		case 1:
			start = 0;
			end = 1;
			break;
		case 2:
			start = 0;
			end = 4;
			break;
		case 3:
			start = 1;
			end = 4;
	}
	#ifdef CGA
	for (i=0; i<8; i++)
	#endif
	#ifndef CGA
	for (i=0; i<14; i++)
	#endif
	{
		for (j=0; j<8; j++)
		{
			for (m=start; m<end; m++)
			{
				for (k=start; k<end; k++)
				{
					switch(type)
					{
						case 0:
							height = y+i;
							width = x+j;
                                        		break;
						case 1:
							height = y-j;
							width = x+i;
							break;
						case 2:
						case 3:
							height = y+4*i+k;
							width = x+4*j+m;
					}
					char_test = 0x80 >> j;
				        if ((char_table[char_offset+i] &
						char_test) != 0)
						point_color = foreground;
					else
						point_color = background;
					#ifdef CGA
					plot(width,height,point_color);
					#endif

					#ifndef CGA
					offset = (long)(height) * 80L +
						((long)(width) / 8L);
					mem_address = (char far *)0xA0000000L
						+ offset;
					mask = 0x80 >> ((width) % 8);
					graph_out(8,mask);
					seq_out(2,0x0F);
					dummy = *mem_address;
					*mem_address = 0;
					seq_out(2,point_color);
					*mem_address = 0xFF;
					#endif
				}
			}
		}
	}
	#ifndef CGA
	seq_out(2,0x0F);
	graph_out(3,0);
	graph_out(8,0xFF);
	#endif
}
